/* 
   - The contents of this file are subject to the Mozilla Public
   - License Version 1.1 (the "License"); you may not use this file
   - except in compliance with the License. You may obtain a copy of
   - the License at http://www.mozilla.org/MPL/
   -
   - Software distributed under the License is distributed on an "AS
   - IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
   - implied. See the License for the specific language governing
   - rights and limitations under the License.
   -
   - The Original Code is this file as it was released on
   - March 20, 2001.
   -
   - The Initial Developer of the Original Code is Henk-Johan van Rantwijk.
   - Portions created by Henk-Johan van Rantwijk are Copyright (C) 2001
   - Henk-Johan van Rantwijk.  All Rights Reserved.
   -
   - Contributor(s):
   -  Henk-Johan van Rantwijk <bugs4hj@netscape.net> (Original Author)
   -  David Perry <d.perry@utoronto.ca>
   -
   - Alternatively, the contents of this file may be used under the
   - terms of the GNU General Public License Version 2 or later (the
   - "GPL"), in which case the provisions of the GPL are applicable
   - instead of those above.  If you wish to allow use of your
   - version of this file only under the terms of the GPL and not to
   - allow others to use your version of this file under the MPL,
   - indicate your decision by deleting the provisions above and
   - replace them with the notice and other provisions required by
   - the GPL.  If you do not delete the provisions above, a recipient
   - may use your version of this file under either the MPL or the
   - GPL.
   -
*/

////////////////////////////////////////////////////////////////////////////////
function openTabManager()
{
  window.openDialog("chrome://multiviews/content/multiviewsTabManager.xul", "tabmanager",
                     "chrome, dependent, modal, dialog, resizable");
}
////////////////////////////////////////////////////////////////////////////////
function hideTab(aTab)
{
  var clsTab = "close";
  if (aTab.hasAttribute(clsTab))
    aTab.removeAttribute(clsTab);
  else aTab.setAttribute(clsTab, "true");
}
////////////////////////////////////////////////////////////////////////////////
function loadFirstTabPage(aTab)
{
  if (aTab == null)
   aTab = gBrowser.selectedTab;
  var mURI = aTab.getAttribute("firstPage");
  var aBrowser = gBrowser.getBrowserForTab(aTab);
  if (mURI != gBrowser.currentURI.spec && aBrowser)
    aBrowser.loadURI(mURI);
}
////////////////////////////////////////////////////////////////////////////////
function FillSelectedHistoryMenu(aParent, aMenu, aTab)
{
  var sessionHistory = getWebNavigation().sessionHistory;
  var end;
  var j;
  var entry;

  if (aTab) {
    var browser = gBrowser.getBrowserForTab(aTab);
    sessionHistory = browser.sessionHistory;
  }
  var count = sessionHistory.count;
  var index = sessionHistory.index;

  if (aMenu != "global" && count == 0)
    return;
  deleteHistoryItems(aParent);

  switch (aMenu)
    {
      case "go":
        aParent.lastChild.hidden = (count == 0);
        end = count > MAX_HISTORY_MENU_ITEMS ? count - MAX_HISTORY_MENU_ITEMS : 0;
        for (j = count - 1; j >= end; j--) {
          entry = sessionHistory.getEntryAtIndex(j, false);
          if (entry)
            createRadioMenuItem(aParent, j, entry.title, j==index);
        }
      break;

      case "tab":
        aParent.lastChild.hidden = (count > 0);
        end = count > MAX_HISTORY_MENU_ITEMS ? count - MAX_HISTORY_MENU_ITEMS : 0;
        for (j = count - 1; j >= end; j--) {
          entry = sessionHistory.getEntryAtIndex(j, false);
          if (entry)
            createRadioMenuItem(aParent, j, entry.title, j==index);
        }
      break;

      case "global":
        var history = document.getElementById("globalHistoryTree");
        var historyIndex = count = history.treeBoxObject.view.rowCount;
        dump('\ncount = '+(count == 0));
        aParent.childNodes[10].hidden = (count == 0);

        if (count > MAX_HISTORY_MENU_ITEMS)
          count = MAX_HISTORY_MENU_ITEMS;
        if (count == 0)
         return;

        var builder = history.builder.QueryInterface(Components.interfaces.nsIXULTreeBuilder);
        var nameResource = RDF.GetResource("http://home.netscape.com/NC-rdf#Name");

        for (j = count-1; j >= 0; j--) {
          var res = builder.getResourceAtIndex(j);
          var url = res.Value;
          var titleRes = history.database.GetTarget(res, nameResource, true);
          if (!titleRes)
            continue;

          var title = titleRes.QueryInterface(Components.interfaces.nsIRDFLiteral);
          createRadioMenuItem(aParent, (historyIndex-j), title.Value, (j+historyIndex)==index);
        }
      break;
    }
}
////////////////////////////////////////////////////////////////////////////////
function updateGoMenuPopup(aPopupMenu)
{
  var tabs = getBrowser().mPanelContainer.childNodes.length;
  var disabled = tabs == 1;
  var menuItems = aPopupMenu.getElementsByAttribute("tbattr", "tabbrowser-multiple");
  for (var i = 0; i < menuItems.length; i++)
    menuItems[i].setAttribute("disabled", disabled);
}
////////////////////////////////////////////////////////////////////////////////
function closeTabOrWindow() 
{
  var tabs = getBrowser().mTabContainer.childNodes.length;
  if (!getBrowser().mTabbedMode && confirmCloseWS(1))
    BrowserCloseWindow(); 
  else if (tabs == 1 && getBrowser().mCurrentBrowser.currentURI.spec == "about:blank" && 
           confirmCloseWS(1))
    BrowserCloseWindow(); 
  else gBrowser.removeCurrentTab();
}
////////////////////////////////////////////////////////////////////////////////
function gotoHistoryPage(aEvent)
{
  var index = aEvent.getAttribute('index');
  getWebNavigation().gotoIndex(index);
}
////////////////////////////////////////////////////////////////////////////////
function preventDupeTab(href)
{
  if (readMyPref("multizilla.prevent.double", "bool", true) && href.substring(0,10) != "javascript") {
    gBrowser = getBrowser();
    var tabHref = null;
    var baseHref = href.replace(/#.*/, "");
    if (baseHref[baseHref.length-1] == '/')
      baseHref = baseHref.substring(0, baseHref.length-1);
    for (var i = 0; i < gBrowser.mTabContainer.childNodes.length; i++) {
      if (gBrowser.mTabContainer.childNodes[i].hasAttribute("busy"))
        tabHref = gBrowser.mTabContainer.childNodes[i].getAttribute("firstPage");
      else 
        tabHref = gBrowser.mPanelContainer.childNodes[i].webNavigation.currentURI.spec;
      tabHref = tabHref.replace(/#.*/, "");
      if (tabHref[tabHref.length-1] == '/')
        tabHref = tabHref.substring(0, tabHref.length-1);
      var tab = gBrowser.mTabContainer.childNodes[i];
      if (baseHref == tabHref) {
        if (gBrowser.selectedTab == tab)
          loadURI(href);
        else {
          gBrowser.selectedTab = tab;
          if (href.indexOf("#") != -1)
            loadURI(href); // anchor link like webpage.html#anchor
        }
        return tab;
      }
    }
  }
  return null;
}
////////////////////////////////////////////////////////////////////////////////
function checkForBlankTab()
{
  if (readMyPref("multizilla.tabs.blank-tab-first", "bool", true)) {
    var page = "about:blank";
    var browser = getBrowser();
    var tabs = browser.mPanelContainer.childNodes.length;
    for (var i = 0; i < tabs; i++) {
      if (browser.mTabContainer.childNodes[i].hasAttribute("busy"))
        page = browser.mTabContainer.childNodes[i].getAttribute("firstpage");
      else page = browser.mPanelContainer.childNodes[i].currentURI.spec
      if (page == "about:blank")
        return browser.mPanelContainer.childNodes[i];
    }
  }
  return null;
}
////////////////////////////////////////////////////////////////////////////////
function openNewTabOrNewWindow()
{
  if (readMyPref("multizilla.newtabfor.ctrl-n", "bool", true)) {
    var aTab = gBrowser.selectedTab = gBrowser.addPreferredTab();
    if (readMyPref("browser.tabs.loadInBackground", "bool", true))
      getBrowser().selectedTab = aTab;
      setTimeout("gURLBar.focus();", 0);
  }
  else OpenBrowserWindow();
}
////////////////////////////////////////////////////////////////////////////////
function initMoveTabMenu(aID) 
{
  var windowManagerDS = Components.classes['@mozilla.org/rdf/datasource;1?name=window-mediator'].getService(nsIWindowDataSource);
  var item = document.getElementById(aID);

  while ((item = item.nextSibling)) {
    var url = item.getAttribute('id');
    var win = windowManagerDS.getWindowForResource(url);
    if (win && win == window) {
      item.setAttribute("checked", "true");
      item.setAttribute("disabled", "true");
    }
    else if (win.document.documentElement.getAttribute("windowtype") != "navigator:browser")
      item.setAttribute("disabled", "true");
  }
}
////////////////////////////////////////////////////////////////////////////////
function moveTabToWindow(aTab, aWindowID)
{
  var windowManagerDS = Components.classes['@mozilla.org/rdf/datasource;1?name=window-mediator'].getService(nsIWindowDataSource);
  var win = windowManagerDS.getWindowForResource(aWindowID);

  if (win && win.document.documentElement.getAttribute("windowtype") != "navigator:browser") {
    var loadInBackground = pref.getBoolPref("browser.tabs.loadInBackground");
    var aURL = gBrowser.getBrowserForTab(aTab).currentURI.spec;
    if (aURL) {
      var newTab = win.gBrowser.addTab(aURL, null);
      if (!loadInBackground)
        win.gBrowser.selectedTab = newTab;
      gBrowser.removeTab(aTab);
    }
  }
}
////////////////////////////////////////////////////////////////////////////////
function moveTabToNewWindow(aTab)
{
  var aBrowser = gBrowser.getBrowserForTab(aTab);
  var aURL = aBrowser.currentURI.spec;
  if (aURL && aURL != "about:blank")
    window.open(aURL);
  gBrowser.removeTab(aTab);
}
////////////////////////////////////////////////////////////////////////////////
function doFKey(aFunctionKey)
{
  aFunctionKey--;
  if (aFunctionKey > -1 && aFunctionKey < gBrowser.mTabList.length)
    gBrowser.selectedTab = gBrowser.mTabList[aFunctionKey];
}
//////////////////////////////////////////////////////////////////////////
function addNewTabFromClipboard()
{
  var aURL = getLocationFromClipboard();
  if (aURL)
    gBrowser.selectedTab = gBrowser.addTab(aURL);
}
//////////////////////////////////////////////////////////////////////////
function advanceSelectedTab(aDir)
{
  var startTab = gBrowser.selectedTab;
  var startIndex = Number(startTab.ordinal);
  var tabs = gBrowser.mTabList;
  var nextIndex = startIndex+aDir;
  var tab = null;

    if (nextIndex < 0 || nextIndex > gBrowser.mTabList.length-1)
      tab = (aDir == -1) ? tabs[tabs.length-1] : tabs[0];
    else 
      tab = tabs[nextIndex];

    if (tab && tab != startTab) {
      gBrowser.selectedTab = tab;
      tab.focus();
      document.commandDispatcher.advanceFocusIntoSubtree(tab);
    }
}
//////////////////////////////////////////////////////////////////////////
function doReload(aEvent, reloadAll)
{
  aEvent.preventBubble();
  if (aEvent.ctrlKey || reloadAll)
    gBrowser.reloadAllTabs(aEvent.shiftKey ? true : false);
  else if (aEvent.shiftKey)
    BrowserReloadSkipCache();
  else
    BrowserReload();
}
//////////////////////////////////////////////////////////////////////////
function doStop(aEvent, stopAll)
{
  aEvent.preventBubble();
  if (aEvent.ctrlKey || stopAll)
    gBrowser.stopAllTabs();
  else 
    BrowserStop();
}

