/* 
   - The contents of this file are subject to the Mozilla Public
   - License Version 1.1 (the "License"); you may not use this file
   - except in compliance with the License. You may obtain a copy of
   - the License at http://www.mozilla.org/MPL/
   -
   - Software distributed under the License is distributed on an "AS
   - IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
   - implied. See the License for the specific language governing
   - rights and limitations under the License.
   -
   - The Original Code is this file as it was released on
   - March 20, 2001.
   -
   - The Initial Developer of the Original Code is Henk-Johan van Rantwijk.
   - Portions created by Henk-Johan van Rantwijk are Copyright (C) 2001
   - Henk-Johan van Rantwijk.  All Rights Reserved.
   -
   - Contributor(s):
   -  Henk-Johan van Rantwijk <bugs4hj@netscape.net> (Original Author)
   -  Rajnish Bhaskar <raj@lordofthemoon.com>
   -
   - Alternatively, the contents of this file may be used under the
   - terms of the GNU General Public License Version 2 or later (the
   - "GPL"), in which case the provisions of the GPL are applicable
   - instead of those above.  If you wish to allow use of your
   - version of this file only under the terms of the GPL and not to
   - allow others to use your version of this file under the MPL,
   - indicate your decision by deleting the provisions above and
   - replace them with the notice and other provisions required by
   - the GPL.  If you do not delete the provisions above, a recipient
   - may use your version of this file under either the MPL or the
   - GPL.
   -
*/

///////////////////////////////////////////////////////////////////////////////
function initGroupPref(menuElement)
{
  var prefGroup = menuElement.getAttribute("prefgroup");
  var prefElements = document.getElementsByAttribute("prefgroup", prefGroup);

  if (prefElements.length == 0)
    return;

  var prefType = prefElements[1].getAttribute("preftype");
  var prefDefval = prefElements[1].getAttribute("prefdefval");
  var prefIdentifier = prefElements[1].getAttribute("prefstring");
  var prefDefaultFlag = true;
  var prefValue = readMyPref(prefIdentifier, prefType, 0, prefDefaultFlag);

  for (var i = 1; i < prefElements.length; i++) {
    if (prefElements[i].getAttribute("prefvalue") == prefValue)
      prefElements[i].setAttribute("checked", "true");       
    else
      prefElements[i].removeAttribute("checked");
  }
}
////////////////////////////////////////////////////////////////////////////////
function changePref(menuElement, menuGroup, doRefresh)
{
  var prefType = menuElement.getAttribute("preftype");
  var prefIdentifier = menuElement.getAttribute("prefstring");
  var prefDefval = menuElement.getAttribute("prefdefval");
  var prefAttribute = null;
  var prefArray = new Array();
  var noAccess = "noAccess";
  var allAccess = "allAccess";
	
  if (prefIdentifier != null) {
    // retrieve current value
    var prefValue = readMyPref(prefIdentifier, prefType, prefDefval);

    if (prefType == "bool") // flip flop the pref
      writePref(prefType, prefIdentifier, !prefValue);
    else {
      if (menuGroup) // special case, use this value
        prefValue = menuElement.getAttribute("prefvalue");
      else { // used for int and string, other might follow
        prefAttribute = menuElement.getAttribute("prefattribute");

        if (prefAttribute == "checked") {
          // setup an array with values to use
          prefValues = eval(menuElement.getAttribute("prefvalue"));
	        prefArray = prefValues;
          // pick the first or second value, based on the "checked" state
          prefValue = menuElement.getAttribute(prefAttribute) ? prefArray[1] : prefArray[0];
        }
        else
          prefValue = menuElement.getAttribute(prefAttribute);
      }
      // Ok, lets write this sucker
      writePref(prefType, prefIdentifier, prefValue);
    }
    if (doRefresh) // this pref setting needs a refresh
      getWebNavigation().reload(nsIWebNavigation.LOAD_FLAGS_IS_REFRESH);
  }
}
////////////////////////////////////////////////////////////////////////////////
function initQuickPrefs()
{
  var prefElements = document.getElementsByAttribute("pref", "true");

  for (var i = 0; i < prefElements.length; i++) {
    var prefId = prefElements[i].getAttribute("id");
    var prefType = prefElements[i].getAttribute("preftype");
    var prefIdentifier = prefElements[i].getAttribute("prefstring");
    var prefDefval = prefElements[i].getAttribute("prefdefval");
    var prefAttribute = prefElements[i].getAttribute("prefattribute");
    var prefValue;

    prefValue = readMyPref(prefIdentifier, prefType, prefDefval);

    if (prefAttribute == "checked") {
      if (prefValue >= 1)
        prefElements[i].setAttribute(prefAttribute, "true");
      else prefElements[i].removeAttribute(prefAttribute);
    }
    else 
      prefElements[i].setAttribute(prefAttribute, prefValue);
  }
}
////////////////////////////////////////////////////////////////////////////////
// this code is copied from cookieNavigatorOverlay.xul and changed accordantly
// and it is always available for the end-user. We don't check the pref :-)
////////////////////////////////////////////////////////////////////////////////
function aCheckForVisibility()
{
  permissionmanager = Components.classes["@mozilla.org/permissionmanager;1"]
                                .getService(Components.interfaces.nsIPermissionManager);
  popupmanager = Components.classes["@mozilla.org/PopupWindowManager;1"]
                           .getService(Components.interfaces.nsIPopupWindowManager);
  var uri = getBrowser().currentURI;
  var blocked;
  // var blocked = permissionmanager.testForBlocking(window._content.location, COOKIEPERMISSION);
  // var blocked = permissionmanager.testPermission(uri, nsIPermissionManager.COOKIE_TYPE);
  // latest modification for cookieNavigatorOverlay.xul (v 1.17/Jul 8 17:20)
  blocked = permissionmanager.testPermission(uri, "cookie");
  // enableElement("qpm_AllowCookies", blocked);
  enableElement("qpm_AllowCookies", blocked != nsIPermissionManager.ALLOW_ACTION);
  // enableElement("qpm_BlockCookies", !blocked);
  enableElement("qpm_BlockCookies", blocked != nsIPermissionManager.DENY_ACTION);
  // blocked = permissionmanager.testForBlocking(window._content.location, IMAGEPERMISSION);
  // blocked = permissionmanager.testPermission(uri, nsIPermissionManager.IMAGE_TYPE);
  // latest modification for cookieNavigatorOverlay.xul (v 1.17/Jul 8 17:20)
  blocked = permissionmanager.testPermission(uri, "image");
  // enableElement("qpm_AllowImages", blocked);
  enableElement("qpm_AllowImages", blocked != nsIPermissionManager.ALLOW_ACTION);
  // enableElement("qpm_BlockImages", !blocked);
  enableElement("qpm_BlockImages", blocked != nsIPermissionManager.DENY_ACTION);

  // var suitable = popupmanager.testSuitability(getBrowser().currentURI);
  // blocked = false;
  blocked = nsIPermissionManager.UNKNOWN_ACTION;
  // var policy = pref.getBoolPref("dom.disable_open_during_load");
  // blocked = permissionmanager.testPermission(uri, nsIPermissionManager.POPUP_TYPE);
  // latest modification for cookieNavigatorOverlay.xul (v 1.17/Jul 8 17:20)
  blocked = permissionmanager.testPermission(getBrowser().currentURI, "popup");

  /* if (suitable) {
    if (!policy) // blacklist, test if there is a permission set
      // blocked = (popupmanager.testPermission(getBrowser().currentURI) == Components.interfaces.nsIPopupWindowManager.DENY_POPUP);
    else { // whitelist, check if it is on list
      blocked = true;
      var enumerator = popupmanager.getEnumerator();
      while (enumerator.hasMoreElements()) {
        var permission = enumerator.getNext().QueryInterface(Components.interfaces.nsIPermission);
        if (permission.capability && getBrowser().currentURI.host == permission.host) {
          blocked = false;
          break;
        }
      }
    }
  } */

  // enableElement("qpm_BlockPopups", suitable && !blocked);
  enableElement("qpm_BlockPopups", blocked != nsIPermissionManager.DENY_ACTION);
  // enableElement("qpm_AllowPopups", suitable && blocked);
  enableElement("qpm_AllowPopups", blocked != nsIPermissionManager.ALLOW_ACTION)
  enableElement("qpm_ManagePopups", true);
}
///////////////////////////////////////////////////////////////////////////////
// This function is added for compatibility issues with Netscape 7
////////////////////////////////////////////////////////////////////////////////
/* function aCheckForVisibility()
{
  var permissionmanager = Components.classes["@mozilla.org/permissionmanager;1"].getService(Components.interfaces.nsIPermissionManager);
  var blocked = permissionmanager.testForBlocking(window._content.location, COOKIEPERMISSION);
  enableElement("qpm_AllowCookies", blocked);
  enableElement("qpm_BlockCookies", !blocked);
  blocked = permissionmanager.testForBlocking(window._content.location, IMAGEPERMISSION);
  enableElement("qpm_AllowImages", blocked);
  enableElement("qpm_BlockImages", !blocked);

  var popupmanager = Components.classes["@mozilla.org/PopupWindowManager;1"].getService(Components.interfaces.nsIPopupWindowManager);
  var pref;
  pref = Components.classes['@mozilla.org/preferences-service;1'];
  pref = pref.getService();
  pref = pref.QueryInterface(Components.interfaces.nsIPrefBranch);
  var useManager = !pref.getBoolPref("dom.disable_open_during_load") &&
                    pref.getIntPref("privacy.popups.policy") == Components.interfaces.nsIPopupWindowManager.ALLOW_POPUP &&
                    pref.getBoolPref("privacy.popups.usecustom");
  var suitable = false;
  var enableBlock = false;
  if (useManager) {
    suitable = popupmanager.testSuitability(getBrowser().currentURI);
    if (suitable)
      enableBlock = popupmanager.testPermission(getBrowser().currentURI) != Components.interfaces.nsIPopupWindowManager.DENY_POPUP;
  }
  enableElement("qpm_BlockPopups", useManager && suitable && enableBlock);
  enableElement("qpm_AllowPopups", useManager && suitable && !enableBlock);
  enableElement("qpm_ManagePopups", useManager);
}
var WINDOWPERMISSION = 2; */
///////////////////////////////////////////////////////////////////////////////
// This function is added for compatibility issues with Netscape 7
////////////////////////////////////////////////////////////////////////////////
/* function viewPopups() {
  window.openDialog("chrome://communicator/content/wallet/CookieViewer.xul","_blank", 
                    "chrome,resizable=yes", "popupManager" );
} */
///////////////////////////////////////////////////////////////////////////////
// This function is added for compatibility issues with Netscape 7
////////////////////////////////////////////////////////////////////////////////
/* function enableElement(elementID, enable) {
  var element = document.getElementById(elementID);
    if (enable)
      element.removeAttribute("disabled");
    else
      element.setAttribute("disabled", "true");
} */
///////////////////////////////////////////////////////////////////////////////
// This is a rewrite of aCookieImageAction() in cookieNavigatorOverlay.xul 
////////////////////////////////////////////////////////////////////////////////
function aCIPAction(element) {
  var permissionmanager = Components.classes["@mozilla.org/permissionmanager;1"].getService(Components.interfaces.nsIPermissionManager);
  // var permission = (element.getAttribute("permission") == "true") ? true : false;
  var permission = (element.getAttribute("permission") == "true") ? nsIPermissionManager.ALLOW_ACTION : nsIPermissionManager.DENY_ACTION;
  var action = element.getAttribute("for")
  var uri = getBrowser().currentURI;

  switch (action) {
    case "qpm_CookieAction":
      // permissionmanager.add(uri, permission, COOKIEPERMISSION);
      // permissionmanager.add(uri, nsIPermissionManager.COOKIE_TYPE, permission);
      // latest modification for cookieNavigatorOverlay.xul (v 1.17/Jul 8 17:20)
      permissionmanager.add(uri, "cookie", permission);
      break;
    case "qpm_ImageAction":
      // permissionmanager.add(uri, permission, IMAGEPERMISSION);
      // permissionmanager.add(uri, nsIPermissionManager.IMAGE_TYPE, permission);
      // latest modification for cookieNavigatorOverlay.xul (v 1.17/Jul 8 17:20)
      permissionmanager.add(uri, "image", permission);
      break;
  }
  alert(element.getAttribute("msg"));
}
////////////////////////////////////////////////////////////////////////////////
function getUserAgentFromLocalstore(aParent)
{
  var addMenuItems = true;
  if (aParent.childNodes.length > 3)
    addMenuItems = false;

  /* Include these lines for the stand-alone versions of QPM only!
  var RDF = Components.classes["@mozilla.org/rdf/rdf-service;1"]
                        .getService(Components.interfaces.nsIRDFService);
  initializeRDFStorageFile(); */
  var RDFC = Components.classes["@mozilla.org/rdf/container-utils;1"]
                       .getService(Components.interfaces.nsIRDFContainerUtils);
  var userAgents = RDFC.MakeSeq(mzRDFStore, RDF.GetResource("urn:useragent-data")).GetElements();
  if (!userAgents.hasMoreElements()) {
    return;
  }
  var index = 0;
  var selected = 0;
  var uaOverride = null;
  try { 
    uaOverride = pref.getCharPref("general.useragent.override"); 
  } catch(ex) {
  }
  while (userAgents.hasMoreElements()) {
    var userAgent = userAgents.getNext();
    if (userAgent) {
      try {
        userAgent = userAgent.QueryInterface(Components.interfaces.nsIRDFLiteral);
        index++;
      } catch(ex) {
        continue;
      }
      if (addMenuItems)
        createRadioMenuItem(aParent, index, userAgent.Value, (uaOverride == userAgent.Value) ? true : false);
      if (uaOverride && uaOverride == userAgent.Value)
        selected = index + 2;
    }
  }
  aParent.childNodes[2].setAttribute("hidden", "true");
  if (selected == 0) {
    if (uaOverride)
      createRadioMenuItem(aParent, index + 3, uaOverride, true);
    else aParent.childNodes[0].setAttribute("checked", "true");
  }
  return;
}
////////////////////////////////////////////////////////////////////////////////
function setUserAgentOverrideTo(index, aIdentifier)
{
  if (!index) {
    writePref("char", "general.useragent.override", null);
    pref.clearUserPref("general.useragent.override");
  }
  else
    writePref("char", "general.useragent.override", aIdentifier);
  loadURI("about:");
}
////////////////////////////////////////////////////////////////////////////////
function initRefSpoofingMenu(aElement)
{
  var refSetting = -1;
  var spoofURL = "http://ref.spoof.org/refspoof.cgi"; // default fake referrer
  var aWindow = gBrowser.contentWindow;
  var aDocument = aWindow.document;
  var qpmBundle = srGetStrBundle("chrome://multiviews/locale/quickPrefsMenu.properties");
  try { 
    refSetting = pref.getIntPref("network.http.sendRefererHeader");
  } catch (ex) {
  }
  for (var i = 0; i < aElement.childNodes.length; i++) {
    aElement.childNodes[i].setAttribute("disabled", (refSetting == 0) ? "true" : "false");
    aElement.childNodes[i].setAttribute("checked", "false");
  }
  try {
    spoofURL = readMyPref("multizilla.refspoof.spoofurl", "string", spoofURL);
  } catch (ex) {
  }
  aElement.childNodes[6].setAttribute("label", qpmBundle.GetStringFromName("fake.label") + " " + spoofURL);
  aElement.childNodes[7].setAttribute("label", aDocument.referrer ?  
                                               qpmBundle.GetStringFromName("currentRef.label") + " " + aDocument.referrer : 
                                               qpmBundle.GetStringFromName("noRef.label"));

  if (refSetting)
    initGroupPref(aElement);
}
////////////////////////////////////////////////////////////////////////////////
function displayWarn(messageNumber)
{
  var msg = null;
  var qpmBundle = srGetStrBundle("chrome://multiviews/locale/quickPrefsMenu.properties");

  switch(messageNumber) {
    case 0: msg = qpmBundle.GetStringFromName("refSpooferDisabled");
      break;
    case 1: msg = qpmBundle.GetStringFromName("refSpooferEnabled");
      break;
    case 2: msg = qpmBundle.GetStringFromName("refSpooferNone");
      break;
    case 3: msg = qpmBundle.GetStringFromName("illegalFakeReferrer");
      break;
    case 4:
    case 5: var spoofer = readMyPref("multizilla.refspoof.spoofing", "int", 1);
            msg = (spoofer == 1) ? qpmBundle.GetStringFromName("refSpooferDisabled") : qpmBundle.GetStringFromName("refSpooferEnabled");
      break;
  }
  if (msg)
    alert(msg);
}
////////////////////////////////////////////////////////////////////////////////
function manageFakeReferrer()
{
  var qpmBundle = srGetStrBundle("chrome://multiviews/locale/quickPrefsMenu.properties");
  var dialogTitle = qpmBundle.GetStringFromName("fakeReferrerDialogTitle");
  var dialogText = qpmBundle.GetStringFromName("fakeReferrerDialogText");
  var fakeRefIsText = qpmBundle.GetStringFromName("fakeRefIsSetTo");
  var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService();
  var fakeReferrer = readMyPref("multizilla.refspoof.spoofurl", "url", "http://ref.spoof.org/refspoof.cgi");
  var result = {value:fakeReferrer};

  promptService = promptService.QueryInterface(Components.interfaces.nsIPromptService);
  var ret = promptService.prompt(window, dialogTitle, dialogText, result, null, {value:0});

  if (ret && result.value && result.value != "") {
    alert(fakeRefIsText+result.value);
    writePref("string", "multizilla.refspoof.spoofurl", result.value);
  }
  else
    displayWarn(3);
}
//////////////////////////////////////////////////////////////////////////
function confirmAction(titlePtr, textPtr)
{
  var qpmBundle = srGetStrBundle("chrome://multiviews/locale/quickPrefsMenu.properties");
  var aDialogTitle = qpmBundle.GetStringFromName(titlePtr);
  var aDialogText = qpmBundle.GetStringFromName(textPtr);
  var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService();
  promptService = promptService.QueryInterface(Components.interfaces.nsIPromptService);
  return promptService.confirm(window, aDialogTitle, aDialogText);
}
//////////////////////////////////////////////////////////////////////////
function clearDiskMemCache()
{
  clearCache('STORE_ON_DISK');
  clearCache('STORE_IN_MEMORY');
}
////////////////////////////////////////////////////////////////////////////////
function clearAllBackTraces()
{
  clearGlobalHistory();
  clearUrlBarHistory();
  clearCache("STORE_ON_DISK");
  clearCache("STORE_IN_MEMORY");
}
////////////////////////////////////////////////////////////////////////////////
function clearGlobalHistory()
{
  var globalHistory = Components.classes["@mozilla.org/browser/global-history;1"].getService(Components.interfaces.nsIBrowserHistory);
  globalHistory.removeAllPages();
}
////////////////////////////////////////////////////////////////////////////////
function clearUrlBarHistory()
{
  var urlBarHistory = Components.classes["@mozilla.org/browser/urlbarhistory;1"].getService(Components.interfaces.nsIUrlbarHistory);
  urlBarHistory.clearHistory();
}
////////////////////////////////////////////////////////////////////////////////
function clearCache(aCache)
{
  var classID = Components.classes["@mozilla.org/network/cache-service;1"];
  var cacheService = classID.getService(Components.interfaces.nsICacheService);

  if (aCache == "STORE_ON_DISK")
    cacheService.evictEntries(Components.interfaces.nsICache.STORE_ON_DISK);
  else if (aCache == "STORE_IN_MEMORY")
    cacheService.evictEntries(Components.interfaces.nsICache.STORE_IN_MEMORY);
}
////////////////////////////////////////////////////////////////////////////////
function togglePackage(aEvent)
{
  var packageName = aEvent.originalTarget.getAttribute("extensionName");
  var disabledState = aEvent.originalTarget.getAttribute("disabledState");
  alert(packageName+"\n"+disabledState ? "enabled" : "disabled");
  try {
    var chromeRegistry = Components.classes["@mozilla.org/chrome/chrome-registry;1"].getService();
    if (chromeRegistry)
      chromeRegistry = chromeRegistry.QueryInterface(Components.interfaces.nsIXULChromeRegistry);
  } catch(ex) { dump(ex) } // die silently
  chromeRegistry.setAllowOverlaysForPackage(packageName, disabledState ? true: false);
}
////////////////////////////////////////////////////////////////////////////////
function reenableMultiZilla()
{
  togglePackage("multiviews", true);
}
//////////////////////////////////////////////////////////////////////////
// Returns nsiURI. This is used in function initializeRDFStorage()
function getProfileURI()
{
  var profile = Components.classes["@mozilla.org/profile/manager;1"].getService(Components.interfaces.nsIProfileInternal);
  var gIOService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
  var URI = gIOService.newFileURI(profile.getProfileDir(profile.currentProfile));
  return URI || null;
}
////////////////////////////////////////////////////////////////////////////////
// This initializes or build a new RDF
function initializeRDFStorageFile()
{
  var rdfFile = "multizilla.rdf"; // "quickprefs.rdf" for stand-alone versions of QPM
  // Get profile directory of current profile
  var profileURI = getProfileURI();
  // Construct file handler to our RDF storage file
  const ioService = Components.classes['@mozilla.org/network/io-service;1']
                              .getService(Components.interfaces.nsIIOService);
  var gFileHandler = ioService.getProtocolHandler("file")
                              .QueryInterface(Components.interfaces.nsIFileProtocolHandler);
  var storageFile = gFileHandler.getFileFromURLSpec(profileURI.spec + rdfFile)
                                .QueryInterface(Components.interfaces.nsILocalFile);
  // Check if "multizilla.rdf" exists
  if (!storageFile.exists()) {
    /* The RDF is missing, we need to construct one ourself as fallback
       Note: this has partly been ported from C++ (nsLocalStore.cpp#410) */
    const defaultRDF = "<?xml version=\"1.0\"?>\n" +
                       "<RDF:RDF xmlns:RDF=\"http://www.w3.org/1999/02/22-rdf-syntax-ns#\"\n" +
                       "         xmlns:MZ=\"http://multizilla.mozdev.org/rdf#\">\n" +
                       "  <!-- Empty -->\n" +
                       "</RDF:RDF>\n";
    /* Create a new RDF
       See also: http://lxr.mozilla.org/seamonkey/source/netwerk/base/public/nsIFileStreams.idl
            and: http://lxr.mozilla.org/seamonkey/source/nsprpub/pr/include/prio.h */
	storageFile.create(storageFile.NORMAL_FILE_TYPE, 0666);
    // Setup a stream
    var stream = Components.classes['@mozilla.org/network/file-output-stream;1']
                           .createInstance(Components.interfaces.nsIFileOutputStream);
    // Initialize the new RDF
    stream.init(storageFile, 2, 0x200, false);
    // Write the XML data into our RDF
    stream.write(defaultRDF, defaultRDF.length);
    // Close the stream
    stream.close();
  }
  // We should have a RDF by now. Initialize global 'mzRDFStore'
  mzRDFStore = RDF.GetDataSource(profileURI.spec + rdfFile);
}

